# Custom Pages ## List custom pages `client.customPages.list(CustomPageListParamsparams?, RequestOptionsoptions?): SinglePage` **get** `/{accounts_or_zones}/{account_or_zone_id}/custom_pages` Fetches all the custom pages. ### Parameters - `params: CustomPageListParams` - `account_id?: string` The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `CustomPageListResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const customPageListResponse of client.customPages.list({ account_id: 'account_id' })) { console.log(customPageListResponse.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "id": "basic_challenge", "created_on": "2014-01-01T05:20:00.12345Z", "description": "Basic Challenge", "modified_on": "2014-01-01T05:20:00.12345Z", "preview_target": "block:basic-sec-captcha", "required_tokens": [ "::CAPTCHA_BOX::" ], "state": "default", "url": "http://www.example.com" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## Get a custom page `client.customPages.get("1000_errors" | "500_errors" | "basic_challenge" | 7 moreidentifier, CustomPageGetParamsparams?, RequestOptionsoptions?): CustomPageGetResponse` **get** `/{accounts_or_zones}/{account_or_zone_id}/custom_pages/{identifier}` Fetches the details of a custom page. ### Parameters - `identifier: "1000_errors" | "500_errors" | "basic_challenge" | 7 more` Error Page Types - `"1000_errors"` - `"500_errors"` - `"basic_challenge"` - `"country_challenge"` - `"ip_block"` - `"managed_challenge"` - `"ratelimit_block"` - `"under_attack"` - `"waf_block"` - `"waf_challenge"` - `params: CustomPageGetParams` - `account_id?: string` The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `CustomPageGetResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const customPage = await client.customPages.get('ratelimit_block', { account_id: 'account_id' }); console.log(customPage.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "basic_challenge", "created_on": "2014-01-01T05:20:00.12345Z", "description": "Basic Challenge", "modified_on": "2014-01-01T05:20:00.12345Z", "preview_target": "block:basic-sec-captcha", "required_tokens": [ "::CAPTCHA_BOX::" ], "state": "default", "url": "http://www.example.com" } } ``` ## Update a custom page `client.customPages.update("1000_errors" | "500_errors" | "basic_challenge" | 7 moreidentifier, CustomPageUpdateParamsparams, RequestOptionsoptions?): CustomPageUpdateResponse` **put** `/{accounts_or_zones}/{account_or_zone_id}/custom_pages/{identifier}` Updates the configuration of an existing custom page. ### Parameters - `identifier: "1000_errors" | "500_errors" | "basic_challenge" | 7 more` Error Page Types - `"1000_errors"` - `"500_errors"` - `"basic_challenge"` - `"country_challenge"` - `"ip_block"` - `"managed_challenge"` - `"ratelimit_block"` - `"under_attack"` - `"waf_block"` - `"waf_challenge"` - `params: CustomPageUpdateParams` - `state: "default" | "customized"` Body param: The custom page state. - `"default"` - `"customized"` - `url: string` Body param: The URL associated with the custom page. - `account_id?: string` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `CustomPageUpdateResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const customPage = await client.customPages.update('ratelimit_block', { state: 'default', url: 'http://www.example.com', account_id: 'account_id', }); console.log(customPage.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "basic_challenge", "created_on": "2014-01-01T05:20:00.12345Z", "description": "Basic Challenge", "modified_on": "2014-01-01T05:20:00.12345Z", "preview_target": "block:basic-sec-captcha", "required_tokens": [ "::CAPTCHA_BOX::" ], "state": "default", "url": "http://www.example.com" } } ``` ## Domain Types ### Custom Page List Response - `CustomPageListResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page. ### Custom Page Get Response - `CustomPageGetResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page. ### Custom Page Update Response - `CustomPageUpdateResponse` - `id?: string` - `created_on?: string` - `description?: string` - `modified_on?: string` - `preview_target?: string` - `required_tokens?: Array` - `state?: "default" | "customized"` The custom page state. - `"default"` - `"customized"` - `url?: string` The URL associated with the custom page.